"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fadeout = exports.fadein = void 0;
const gsap_1 = __importDefault(require("gsap"));
function fadein(element, options) {
    var _a, _b;
    let duration = (_a = options === null || options === void 0 ? void 0 : options.duration) !== null && _a !== void 0 ? _a : 1;
    let ease = options === null || options === void 0 ? void 0 : options.ease;
    let delay = (_b = options === null || options === void 0 ? void 0 : options.delay) !== null && _b !== void 0 ? _b : 0;
    return new Promise((resolve) => {
        gsap_1.default
            .from(element, { opacity: 0, duration, ease, delay })
            .eventCallback("onComplete", resolve);
    });
}
exports.fadein = fadein;
function fadeout(element, options) {
    var _a, _b, _c;
    let duration = (_a = options === null || options === void 0 ? void 0 : options.duration) !== null && _a !== void 0 ? _a : 0.5;
    let ease = (_b = options === null || options === void 0 ? void 0 : options.ease) !== null && _b !== void 0 ? _b : "Power.easeOut";
    let delay = (_c = options === null || options === void 0 ? void 0 : options.delay) !== null && _c !== void 0 ? _c : 0;
    return new Promise((resolve) => {
        gsap_1.default
            .to(element, { opacity: 0, duration, ease, delay })
            .eventCallback("onComplete", () => {
            element.style.display = "none";
            resolve();
        });
    });
}
exports.fadeout = fadeout;
