"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.togglePosition = void 0;
const gsap_1 = __importDefault(require("gsap"));
const DomFunctions_1 = require("../util/DomFunctions");
function togglePosition(top, bottom, options) {
    var _a, _b, _c;
    let duration = (_a = options === null || options === void 0 ? void 0 : options.duration) !== null && _a !== void 0 ? _a : 0.5;
    let ease = (_b = options === null || options === void 0 ? void 0 : options.ease) !== null && _b !== void 0 ? _b : "Power1.easeOut";
    let DOMupdate = (_c = options === null || options === void 0 ? void 0 : options.DOMupdate) !== null && _c !== void 0 ? _c : true;
    return new Promise((resolve, reject) => {
        try {
            if (top.getBoundingClientRect().y > bottom.getBoundingClientRect().y) {
                let tmp = top;
                top = bottom;
                bottom = tmp;
            }
            const topMarginBottom = parseInt(DomFunctions_1.style(top).marginBottom);
            const bottomMarginTop = parseInt(DomFunctions_1.style(bottom).marginTop);
            const margin = topMarginBottom >= bottomMarginTop ? topMarginBottom : bottomMarginTop;
            gsap_1.default.defaults({ duration, ease });
            gsap_1.default.to(bottom, {
                y: -(DomFunctions_1.height(top) + margin),
            });
            gsap_1.default
                .to(top, {
                y: DomFunctions_1.height(bottom) + margin,
            })
                .eventCallback("onComplete", () => {
                if (DOMupdate) {
                    const parent = top.parentElement;
                    parent === null || parent === void 0 ? void 0 : parent.removeChild(bottom);
                    parent === null || parent === void 0 ? void 0 : parent.insertBefore(bottom, top);
                    gsap_1.default.set(top, { y: 0 });
                    gsap_1.default.set(bottom, { y: 0 });
                }
                if (options === null || options === void 0 ? void 0 : options.callback) {
                    options.callback();
                }
                resolve();
            });
        }
        catch (error) {
            reject();
        }
    });
}
exports.togglePosition = togglePosition;
